/*
 * AuthenticatorImpl.java
 *
 * Created on May 13, 2005, 4:28 PM
 * Created by Detro - 566/2145
 */

package org.jaebi.server.auth;

/**
 * Esempio di implementazione dell'interfaccia Authenticator.
 * 
 * Il comportamento di questa Classe e' comparabile ad
 * una Factory di Session.
 * 
 * @class AuthenticatorImpl
 * @author detro
 */
public class AuthenticatorImpl implements Authenticator {
    /**
     * Creates a new instance of AuthenticatorImpl 
     */
    public AuthenticatorImpl() {}
    
    /**
     * 
     * Genera e restituisce un Session in base al "nick" fornito.
     * 
     * In questa implementazione, il nick viene semplicemente
     * ingnorato. In un altra potrebbe essere, ad esempio,
     * confrontato con un archivio di Utenti pre-registrati.
     */
    public Session getAuthentication(String nick) {
        return new SessionImpl();
    }
    
}
