/*
 * Session.java
 *
 * Created on May 13, 2005, 4:32 PM
 * Created by Detro - 566/2145
 */

package org.jaebi.server.auth;

/**
 * Definisce l'interfaccia per il tipo Session.
 * 
 * Session e' un "identificativo univoco" che viene assegnato ad
 * un utente al suo primo Login e che resta a lui associato per tutta
 * la durata della sua Sessione. Grazie ad esso quindi avremo sempre modo
 * di associare all'utente una serie arbitraria di informazioni (permessi,
 * azioni compiute, ...)
 * 
 * Session e' definito come interfaccia per lasciare la possibilita' di
 * modificare la "natura" dei Session a seconda delle esigenze di progetto.
 * @author detro
 */
public interface Session {
    /** 
     * Metodo utile per comparare due Oggetti.
     *
     * Questo metodo e' necessario per Container come i Set.
     *
     * @param obj Altro oggetto di tipo Session da Comparare
     * @return "true" se uguale, "false" altrimenti
     */
    public boolean equals( Object obj );
    
    /**
     * Ritorna l'hashCode di un Oggetto Session 
     *
     * @return Hashcode int
     */
    public int hashCode();
    
    
    /** 
     * Ritorna una Stringa rappresentante l'Istanza di Session
     *
     * @return Descrizione di Session
     */
    public String toString();
}
