/*
 * User.java
 *
 * Created on May 14, 2005, 1:18 PM
 * Created by Detro - 566/2145
 */

package org.jaebi.server.core;
import org.jaebi.server.auth.Session;
/**
 * Questa Classe incapsula le informazioni circa gli Utenti.
 *
 * @class User
 * @author detro
 */
public class User {
    private final String nick;
    private final Session session;
    private final String type;
    
    /** Creates a new instance of User */
    public User(String newNick, Session newSession, String newType) {
        nick = newNick;
        session = newSession;
        type = newType;
    }

    public String getNick() {
        return nick;
    }

    public Session getSession() {
        return session;
    }

    public String getType() {
        return type;
    }
    
    public boolean equals( Object obj ) {
        if( obj == this ) {
            return true;
        }
        if( obj.getClass() == this.getClass() ) {
            User user = ( User ) obj;
            /* Questo controllo e' necessario perche' Session
             * potrebbe non essere "unico" per scelte implementative */
            if( user.getNick().equals(this.getNick()) &&
                    user.getSession().equals(this.getSession()) &&
                    user.getType().equals(this.getType())
            ) {
                return true;
            }
        }
        return false;
    }
    
    public int hashCode() {
        return toString().hashCode();
    }
    
    public String toString() {
        return "Nick: " + getNick() + " - " + 
                    "Session: " + getSession().toString() + " - " +
                    "Type: " + getType();
    }
    
}
