package org.jaebi.server.service;

import org.jaebi.server.core.User;

/**
 * Questa interfaccia definisce classi di Validazione
 * per i Command da eseguire sul BackEnd.
 * 
 * 
 * @author detro
 */
public interface CommandValidator {
	
	/**
	 * Valida (verifica) se un Command puo' essere eseguito da
	 * uno User.
	 * 
	 * Questa classe permette di filtrare i Command da eseguire, in base
	 * alle autorizzazioni/proprieta'/caratteristiche degli User.
	 * 
	 * Potrebbe, ad esempio, incapsulare un Archivio di User con
	 * associata la mappa delle operazioni consentite ad ognuno.
	 * 
	 * @param user User di cui si vuole Validare il Command
	 * @param command Command da Validare
	 * @return "true" se il Command e' valido, "false" altrimenti
	 */
	public boolean validate(User user, Command command);
}
