/*
 * UniqueRandomIntFactory.java
 *
 * Created on May 21, 2005, 5:14 PM
 * Created by Detro - 566/2145
 */

package org.jaebi.server.util;

import java.util.HashSet;
import java.util.Random;
/**
 * Factory di valori "int" UNICI e Random. 
 *
 * @class UniqueIntFactory
 * @author detro
 */
public class UniqueRandomIntFactory {
    /** 
     * HashSet: Container che
     * 1) Non ammette ripetizioni
     * 2) Esegue l'hashing del valore per capire se e' gia' presente o meno 
     * 3) I punti 1 e 2 rendono HashSet la scelta ideale lo scopo */
    private final HashSet prevValues; 
    /** Generatore casuale di numeri */
    private final Random randomGenerator;

    public UniqueRandomIntFactory() {
        prevValues = new HashSet();
        randomGenerator = new Random();
    }

    public int createUniqueRandomInt() {
        int newValue = randomGenerator.nextInt();
        Integer newValueObj = new Integer(newValue);

        while ( prevValues.contains(newValueObj) ) {
            newValue = randomGenerator.nextInt();
            newValueObj = new Integer(newValue);
        }

        prevValues.add(newValueObj);
        return newValue;
    }
}