/*
 * MainTestServicePackage.java
 *
 * Created on June 11, 2005, 11:49 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package org.jaebi.test.server.service;

import java.io.File;

import org.jaebi.server.service.BackEndHandler;
import org.jaebi.server.service.BackEndHandlerImpl;
import org.jaebi.server.service.XRequestCommand;
import org.jaebi.server.service.XRequestCommandFactory;
import org.jaebi.server.service.exception.BackEndHandlerInitException;
import org.jaebi.server.service.exception.CommandCreationException;
import org.jaebi.server.service.exception.CommandExecException;
import org.jaebi.server.service.exception.XRequestCommandFactoryInitException;
import org.jaebi.server.service.xml.JAXBMarshallerWrapper;
import org.jaebi.server.service.xml.JAXBMarshallerWrapperImpl;
import org.jaebi.server.service.xml.exception.JAXBMarshallerWrapperInitException;
import org.jaebi.server.service.xml.exception.JAXBMarshallerWrapperMarshallException;
import org.jaebi.server.service.xml.exception.JAXBMarshallerWrapperUnmarshallException;
import org.jaebi.server.service.xml.xrequest.Xrequest;
import org.jaebi.server.service.xml.xresponse.Xresponse;

/**
 *
 * @author detro
 */
public class MainTestServicePackage {
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        BackEndHandler beh = null;
        JAXBMarshallerWrapper marshWrap;
        
        Xrequest newReq = null;
        Xresponse newRes = null;
        
        File sourceFile = new File("/Users/detro/workspace-nb/L2-Project-JAEBI/xrequest-example.xml");
        XRequestCommandFactory commFact;
        XRequestCommand newCommand = null;
        
        String result = null;
        
        
        try {
            beh = new BackEndHandlerImpl();
        } catch ( BackEndHandlerInitException behie ) {
            System.out.println("Errore: " + behie);
            behie.printStackTrace();
        }
        
        try {
            marshWrap = new JAXBMarshallerWrapperImpl("org.jaebi.server.service.xml.xrequest");
            newReq = (Xrequest)marshWrap.unmarshall(sourceFile);
        } catch ( JAXBMarshallerWrapperInitException inite) {
            inite.printStackTrace();
        } catch ( JAXBMarshallerWrapperUnmarshallException unmarshe) {
            unmarshe.printStackTrace();
        }
        
        try {
            commFact = new XRequestCommandFactory(beh);
            newCommand = commFact.createCommand(newReq);
        } catch ( XRequestCommandFactoryInitException inite) {
            inite.printStackTrace();
        } catch ( CommandCreationException cce) {
            cce.printStackTrace();
        }
        
        System.out.println("Command Creato: \n" + newCommand );
        
        try {
            newRes = (Xresponse)newCommand.execute();
        } catch ( CommandExecException cee ) {
            cee.printStackTrace();
        }
        
        try {
            JAXBMarshallerWrapper marshWrapResp = new JAXBMarshallerWrapperImpl("org.jaebi.server.service.xml.xresponse");
            marshWrapResp.setFormattedMarshalling(true);
            result = marshWrapResp.marshall(newRes);
        } catch ( JAXBMarshallerWrapperInitException inite) {
            inite.printStackTrace();
        } catch ( JAXBMarshallerWrapperMarshallException marshe) {
            marshe.printStackTrace();
        }
        
        System.out.println("Risultato Command: \n" + result);
    }
    
}
